/*
 * inline.h
 *
 * By Ross Ridge
 * Public Domain
 *
 * @(#) myjis inline.h 1.1 98/06/01 22:30:26
 *
 */

/*
 * Can be included multiple times.
 */

#ifndef __JIS_INLINE_STATIC
#ifdef __cplusplus
#define __JIS_INLINE_STATIC inline
#elif defined(__GNUC__)
#define __JIS_INLINE_STATIC static __inline__
#else
#define __JIS_INLINE_STATIC @ /* this should never be used */
#undef __JIS_NO_INLINE
#define __JIS_NO_INLINE
#endif 
#endif /* __JIS_INLINE_STATIC */

#ifndef __JIS_DEFS_H__
#include "defs.h"
#endif

#undef  __JIS_INLINE_SCCS_ID
#undef  __JIS_INLINE_NAME
#undef  __JIS_INLINE_FUNCTION

#ifdef __JIS_INLINE_DEFINITION

#ifdef __JIS_NO_INLINE

#define __JIS_INLINE_SCCS_ID(id)	/**/
#define __JIS_INLINE_NAME(identifier)	identifier

#define __JIS_INLINE_FUNCTION(return_type, identifier, arglist, body)	\
	extern return_type __JIS_INLINE_NAME(identifier) arglist;

#else  /* __JIS_NO_INLINE */

#define __JIS_INLINE_SCCS_ID(id)	/**/
#define __JIS_INLINE_NAME(identifier)	__jis_inline_##identifier

#define __JIS_INLINE_FUNCTION(return_type, identifier, arglist, body)	\
	extern return_type identifier arglist;				\
	__JIS_INLINE_STATIC return_type					\
	__JIS_INLINE_NAME(identifier) arglist body

#endif /* __JIS_NO_INLINE */

#else /* JIS_INLINE_DEFINITION */

#ifdef JIS_SCCS_IDS
#define __JIS_INLINE_SCCS_ID(id)	static char const sccs_id[] = id;
#else
#define __JIS_INLINE_SCCS_ID(id)	/* id */
#endif

#define __JIS_INLINE_NAME(identifier)	identifier

#define __JIS_INLINE_FUNCTION(return_type, identifier, arglist, body)	\
	return_type							\
	identifier arglist body

#endif /* JIS_INLINE_DEFINITION */

#undef __JIS_INLINE_DEFINITION



