/*
 * w_btow.c
 *
 * By Ross Ridge
 * Public Domain
 *
 * Implementation of jis_byte_to_wide().
 *
 */

#include "defs.h"

#ifdef CONFIG_SCCS_IDS
static char const sccs_id[] = "@(#) myjis j_btow.c 1.1 98/06/01 22:30:34";
#endif

#ifdef __JIS_CONFIG_USE_UNICODE

static CONFIG_INLINE wide_char
roman_to_wide(int c) {
	return __jis_roman_to_wide[c];
}

#else /* __JIS_CONFIG_USE_UNICODE */

static CONFIG_INLINE wide_char
roman_to_wide(int c) {
	return (wide_char) c;
}

#endif /* __JIS_CONFIG_USE_UNICODE */

wide_int
jis_byte_to_wide(int c) {
	if (c == EOF) {
		return WIDE_EOF;
	}
	c = (int) (unsigned char) c;
	if (c > 255) {
		return WIDE_EOF;
	}
	
	switch(__jis_locale_ctype) {
	case JIS_LOCALE_ASCII:
		return (wide_char) c;
		
	case JIS_LOCALE_JIS_ROMAN:
	case JIS_LOCALE_JIS:
		return roman_to_wide(c);

	case JIS_LOCALE_EUC:
		if ((c <= 161 && c != 142 && c != 143) || c == 255) {
			return (wide_char) c;
		}
		return EOF;
       
	case JIS_LOCALE_SHIFT_JIS:
		if (c <= 161 || (c >= 160 && c <= 223)
		    || (c >= 240 && c <= 255)) {
			return roman_to_wide(c);
		}
		return EOF;

#ifdef __JIS_CONFIG_HAVE_UNICODE
	case JIS_LOCALE_UTF8:
		if (c <= 127) {
			return (wide_char) c;
		}
		return EOF;
#endif
		
	case JIS_LOCALE_QUERY:
	case JIS_LOCALE_DEFAULT:
		break;
	}
	abort();
}





