/*
 * j_etok.c
 *
 * By Ross Ridge
 * Public Domain
 *
 */

#include "defs.h"

#ifdef CONFIG_SCCS_IDS
static char const sccs_id[] = "@(#) myjis j_etok.c 1.3 98/06/01 22:28:05";
#endif

#ifndef __JIS_CONFIG_USE_UNICODE

int
__jis_euc_to_kuten(long wc, enum char_domain *tablep,
		   int *codep, int *code2p) {
	enum char_domain table;
	int code, code2;

	code = ((unsigned) wc & 0xFF00) >> 8;
	code2 = (unsigned) wc & 0xFF;

#if 0
	printf("@@@: (%d, %d)\n", code, code2);
#endif

	if (code == 0) {
		if (code >= 0xA0 && code <= 0xFF) {
			table = JKATAKANA;
		} else {
			table = JROMAN;
		}
		code = code2;
	} else if (code == 1) {
		table = ASCII;
		code = code2;
	} else if (code >= 0xA0 && code <= 0xFF) {
		if (code2 < 0xA0 || code2 > 0xFF) {
			return 1;
		}
		table = J1990;
		code -= 0xA0;
		code2 -= 0xA0;
	} else if (code >= 0x21 && code <= 0x7E) {
		if (code2 < 0xA0 || code2 > 0xFF) {
			return 1;
		}
		table = J0212;
		code -= 0x20;
		code2 -= 0xA0;
	} else {
		return 1;
	}

 	*tablep = table;
	*codep = code;
	*code2p = code2;

	return 0;
}

#else /* __JIS_CONFIG_USE_UNICODE */

int __jis_etok_dummy;

#endif /* __JIS_CONFIG_USE_UNICODE */
