/*
 * j_ktou.c
 *
 * By Ross Ridge
 * Public Domain
 *
 */

#include "defs.h"

#ifdef CONFIG_SCCS_IDS
static char const sccs_id[] = "@(#) myjis j_ktou.c 1.4 98/06/01 22:28:09";
#endif

#ifdef __JIS_CONFIG_HAVE_UNICODE

long
__jis_kuten_to_unicode(enum char_domain table, int code, int code2) {
	long wc;

	switch(table) {
	case JROMAN:
		if (code < 127) {
			wc = __jis_roman_to_wide[code];
			if (wc == 0xFFFF) {
				wc = code;
			}
		} else {
			wc = code;
		}
		break;

	case ASCII:
		wc = code;
		break;

	case JKATAKANA:
		wc = __jis_roman_to_wide[code];
		if (wc == 0xFFFF) {
			if (0 && code >= 160) { /* ??? */
				wc = -code;
			} else {
				wc = code;
			}
		}
		break;

	case J1983:
		if (code == 84 && (code2 == 5 || code2 == 6)) {
			wc = 0x10030000L + code * 0x100 + code2;
			break;
		}
		/* FALLTHROUGH */
	case J1990:
		if (code > 94 || code2 > 94) {
			wc = -1;
		} else {
			wc = __jis_1990_to_wide[code][code2];
		}
		if (wc == 0xFFFF) {
			wc = 0x10010000L + code * 0x100 + code2;
		}
		break;

	case J0212:
		if (code > 94 || code2 > 94) {
			wc = -1;
		} else {
			wc = __jis_0212_to_wide[code][code2];
		}
		if (wc == 0xFFFF) {
			wc = 0x10020000L + code * 0x100 + code2;
		}
		break;

	default:
		assert(0);
		abort();
	}

	return wc;
}

#else /* __JIS_CONFIG_HAVE_UNICODE */

int __jis_ktou_dummy;

#endif /* __JIS_CONFIG_HAVE_UNICODE */
