/*
 * j_towdup.c
 *
 * By Ross Ridge
 * Public Domain
 *
 * Implementation of jis_to_wide_dup().
 *
 */

#include "defs.h"

#ifdef CONFIG_SCCS_IDS
static char const sccs_id[] = "@(#) myjis j_towdup.c 1.2 00/05/11 18:17:12";
#endif

#define WORK_BUF_SIZE	256

wide_char *
jis_to_wide_dup(char const *s) {
	wide_char *ws;
	wide_char *tmp;
	size_t len = 0;
	size_t buf_len = WORK_BUF_SIZE;
	size_t n;
	wide_char buf[WORK_BUF_SIZE];
	jis_state state;

	ws = buf;

	state = __jis_initial_state;

	while(1) {
#if 0
		fprintf(stderr,
			"@@@: s = %p, ws = %p, buf_len = %ld, len = %ld\n",
			(void *) s, (void *) ws, (long) buf_len, (long) len);
#endif
	      	n = jis_to_wide_str(ws + len, &s, buf_len - len, &state);
#if 0
		fprintf(stderr, "@@@: n = %ld, s = %p\n",
			(long) n, (void *) s);
#endif
		if (n == (size_t) -1) {
			if (ws != buf) {
				free(ws);
			}
			return NULL;
		}
		len += n;
		if (s == NULL) {
			assert(ws[len] == (wide_char) 0);
			len++;
			if (ws != buf) {
				tmp = realloc(ws, len * sizeof(wide_char));
				if (tmp != NULL) {
					ws = tmp;
				}
			} else {
				ws = malloc(len * sizeof(wide_char));
				if (ws == NULL) {
					return NULL;
				}
				memcpy(ws, buf, len * sizeof(wide_char));
			}
			return ws;
		}
			
		if (n == 0 || len == buf_len) {
#if 0
			fprintf(stderr, "@@@ double\n");
#endif
			buf_len *= 2;
			if (buf_len * sizeof(wide_char) == 0) {
				errno = ENOMEM;
				return NULL;
			}
			if (ws == buf) {
				ws = malloc(buf_len * sizeof(wide_char));
				if (ws == NULL) {
					return NULL;
				}
				memcpy(ws, buf, len * sizeof(wide_char));
			} else {
				tmp = realloc(ws, buf_len * sizeof(wide_char));
				if (tmp == NULL) {
					int save_errno = errno;
					free(ws);
					errno = save_errno;
					return NULL;
				}
				ws = tmp;
			}
		}
	}
}

