/*
 * w_rtoks.c
 *
 * By Ross Ridge
 * Public Domain
 *
 * Implementation of wide_roman_to_kana_str().
 *
 */

#include "defs.h"

#ifdef CONFIG_SCCS_IDS
static char const sccs_id[] = "@(#) myjis w_rtoks.c 1.4 97/02/21 01:16:02";
#endif

int
wide_roman_to_kana_str(wide_char *wd, size_t *plen, wide_char const **pws,
		       int flags) {
	int i;
	size_t n;
	size_t len = *plen;
	wide_char const *ws = *pws;
	int ret = 0;
	struct jis_r2k_kana const *kana;

	while(*ws != '\0' && len > 0) {
		i = wide_roman_to_kana(&kana, 1, ws, flags);
		if (i <= 0) {
			ret |= JIS_R2K_ERR_UNKNOWN;
			*wd++ = *ws++;
			len--;
		} else {
			if (i > 1) {
				ret |= JIS_R2K_ERR_UNKNOWN;
			}
			n = wide_len(kana->kana);
			if (n > len) {
				break;
			}
			memcpy(wd, kana->kana, n * sizeof(wide_char));
			wd += n;
			len -= n;
			ws += strlen(kana->roman);
		}
	}
	
	if (len > 0) {
		*wd++ = (wide_char) 0;
		len--;
	}

	*plen = *plen - len;
	*pws = ws;

	return ret;
}
