/*
 * w_to_hvs.c
 *
 * By Ross Ridge
 * Public Domain
 *
 * Implementation of wide_to_hiragana_vowel_str().
 *
 */

#include "defs.h"

#ifdef CONFIG_SCCS_IDS
static char const sccs_id[] = "@(#) myjis w_to_hvs.c 1.1 96/10/24 18:31:19";
#endif

wide_char *
wide_to_hiragana_vowel_str(wide_char *ws) {
	wide_char *ret = ws;
	wide_int last_vowel = WIDE_EOF;
	wide_int last_was_katakana = 0;
	wide_char wc;

	wc = *ws;
	while(wc != (wide_char) 0) {
		if (wc == K_LONG) {
			switch(last_vowel) {
			case K_O:
				if (last_was_katakana) {
					wc = K_U;
				} else {
					wc = H_U;
				}
				break;

			case K_A:
			case K_E:
			case K_I:
			case K_U:
				wc = last_vowel;
				if (!last_was_katakana) {
					wc = wide_to_hiragana(wc);
				}
				break;
			}
			last_vowel = K_LONG;
		} else {
			last_vowel = wide_to_katakana_vowel(wc);
			last_was_katakana = wide_is_katakana(wc);
		}

		*ws = wc;
		wc = *++ws;
	}
	return ret;
}
